
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Druid 在小米公司部分技术实践 / iVAN</title>

    <meta name="description" content="Druid 在小米公司部分技术实践 引言:Druid作为一款开源的实时大数据分析软件,自诞生以来,凭借自己优秀的特质,不仅逐渐在技术圈收获了越来越多的知名度与口碑,并且陆续成为了很多技术团队解决方案中的关键一环,从而真正在很多公司的技术栈中赢得了一席之地. 本文通过对小米公司技术团队对Druid 的实践案例与经验的介绍,让大家对Druid有更加全面和深入的了解,希望能够帮助你事半功倍地学习Druid 这项年轻的技术. 本文选自&lt;Druid实时大数据分析原理与实践&gt;. 小米公司正式成立于2010 年4 月,是一家专注于高 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Druid 在小米公司部分技术实践</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<blockquote><p>引言：Druid作为一款开源的实时大数据分析软件，自诞生以来，凭借自己优秀的特质，不仅逐渐在技术圈收获了越来越多的知名度与口碑，并且陆续成为了很多技术团队解决方案中的关键一环，从而真正在很多公司的技术栈中赢得了一席之地。<br />
　　 本文通过对小米公司技术团队对Druid 的实践案例与经验的介绍，让大家对Druid有更加全面和深入的了解，希望能够帮助你事半功倍地学习Druid 这项年轻的技术。<br />
　　 本文选自《Druid实时大数据分析原理与实践》。</p></blockquote>
<p>　　小米公司正式成立于2010 年4 月，是一家专注于高端智能手机、互联网电视以及智能家居生态链建设的创新型科技企业。<br />
　　“让每个人都能享受科技的乐趣”是小米公司的愿景。小米公司应用互联网模式开发产品，用工匠精神做产品，用互联网模式节省了中间环节，致力于让全球每个人都能享用来自中国的优质科技产品。<br />
　　　　　　　　　　　<a href="http://img.blog.csdn.net/20170313090548307?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvYnJvYWR2aWV3MjAwNg==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzAzMTMwOTA1NDgzMDc/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2WW5KdllXUjJhV1YzTWpBd05nPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></a><br />
　　　　　　　　　　　　　　　　　　　　　小米大云平台技术架构示意图</p>
<p>　　Druid 在数据分析层帮助实时收集海量的事件数据，快速进行商业分析，在多个场景中都有应用。这里介绍Druid 在小米统计产品和小米广告平台中的部分技术实践。</p>
<h1>场景一：小米统计服务</h1>
<p>　　小米统计是小米为App 开发者提供的移动应用数据统计服务，帮助开发者通过数据了解应用发展状况、渠道推广效果和用户参与情况等信息，使开发者可以更好地优化体验和运营，促进产品不断发展进步。小米统计的入口是tongji.xiaomi.com，服务界面如下。<br />
　　　　　　　　　　　　　　　<a href="http://img.blog.csdn.net/20170313090634616?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvYnJvYWR2aWV3MjAwNg==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzAzMTMwOTA2MzQ2MTY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2WW5KdllXUjJhV1YzTWpBd05nPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></a><br />
　　　　　　　　　　　　　　　　　　　　　小米统计服务界面</p>
<p>　　实时的数据分析重要需求，在产品发展过程中，也经历了几个技术阶段，这几个阶段并非完全互斥，而是应用于不同的场景和时间。<br />
　　第一阶段：数据存储在Hadoop 中，通过MapReduce 的脚本进行分析和处理。有一部分复杂的任务会以天为单位被执行，并且最后会将结果写入到如MySQL 的RDBMS 中。<br />
　　第二阶段：在业务发展过程中MySQL 很快变成了瓶颈，有两个原因，一是数据库的Schema 更改成本高，新业务不断需要增加新列和新表，流程烦琐而且需要进行Schema 设计；二是在进行大量写操作的情况下，数据库的负载增加会导致数据库的读性能下降，而且偶尔有死锁的现象。为了解决这些问题，引入了HBase 作为主要存储数据库，利用HBase 的列族，方便增加数据列。另外，HBase 的可用性也高于MySQL。<br />
　　第三阶段：为了改进数据的实时性，后期增加了Storm 分布式计算模式，使用Storm 可以方便地进行各种复杂的数据处理，各种聚合和处理需要通过程序实现，增加一个数据维度，改动比较大，需要从上游到下游整体修改。这种方式的优点是可靠性好，数据处理能力强，可以进行各种角度的优化。<br />
　　第四阶段：小米统计的很多数据查询都是选择一些指标和过滤条件，很多场景类似于传统的数据仓库，因此引入Druid 处理一些标准报告的实时数据查询场景。数据流会依次通过Kaa 和Tranquility，最后进入Druid 集群。Druid 集群最终能提供最近一天的数据查询功能，并且允许用户直接访问。<br />
　　　　　　　　　　　　　　　　　<a href="http://img.blog.csdn.net/20170313090833711?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvYnJvYWR2aWV3MjAwNg==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzAzMTMwOTA4MzM3MTE/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2WW5KdllXUjJhV1YzTWpBd05nPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></a><br />
　　　　　　　　　　　　　　　　　　　　　　小米统计数据流</p>
<p>　　Druid 作为一种实时分析数据库，提升了小米大数据平台和商业产品部门的实时数据分析能力。</p>
<h1>场景二：广告平台实时数据分析</h1>
<p>　　Druid 来源于广告业务，小米广告平台也利用Druid 进行实时的数据分析，帮助实时分析线上的各种维度的变化，包括上线部署的实时监控分析、A/B 测试的效果查询、一些细粒度的数据分析。<br />
　　对广告数据有两条路径进行处理：一条是实时的数据流，通过Druid 处理，主要是针对内部的实时数据分析需求；另一条是通过Mini-batch 方式。<br />
　　数据的DataSource（数据源）包括：</p>
<ul>
<li>小米广告交易平台（Xiaomi Ad Exchange, MAX）：广告流量的调度管理平台。</li>
<li>广告平台的计费分析模块：广告主的计费、各种维度数据。</li>
<li>广告媒体分析数据：各个广告媒体的请求、展现等数据。</li>
</ul>
<p>比如对于广告计费分析模块，Druid 会包括实时的广告主计费信息，这些数据用于内部的数据分析，不用于广告主投放平台。广告主投放平台使用Mini-batch 方式，通过可重放的方式更新和聚合数据结果。<br />
　　在使用Druid 的过程中也会碰到一些问题。</p>
<h2>1. 关于查询界面</h2>
<p>　　Druid 的查询语言还不是特别友好，在第一阶段部署Druid 后，我们开发了一套Druid查询接口，主要是满足业务的需求，初期效果还好，但是随着数据源的增加，每次增加数据源都需要额外开发一些界面，增加维度，也需要修改前端工程，因此效率也不高。在后期的工作中，尝试了Pivot 工具，功能使用方便，渐渐代替了自定义的查询界面。</p>
<h2>2. 关于查询效率</h2>
<p>　　Druid 的大部分时间性能表现都很好，但是如果进行长时间范围的查询，系统会变得非常慢。为了解决这个问题，对于频繁查询的数据源，可以分为两个部分：一部分是按照分钟级别聚合的数据源，数据保持10 天；另一部分是按照小时级别聚合的数据源，数据保持2年。每天晚上的时候，聚合小时级别的数据，这样可以避开高负载的集群时间。聚合粒度与查询效率的关系如下。<br />
　　　　　　　　　　　　<a href="http://img.blog.csdn.net/20170313090953032?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvYnJvYWR2aWV3MjAwNg==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzAzMTMwOTA5NTMwMzI/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2WW5KdllXUjJhV1YzTWpBd05nPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></a><br />
　　　　　　　　　　　　　　　　　　　　　　　聚合粒度与查询效率的关系</p>
<h2>3. 部署情况</h2>
<p>　　Druid 集群每天处理近百亿的事件请求，集群规模为近10 台机器，索引服务和历史节点数量相当，机器的数量随着事件数的增长而增加。当数据源在某时间数据急剧增加时，系统索引文件所占用的CPU 会很高，有时候影响正常的查询性能。<br />
　　第一阶段，我们尝试在服务层使用流量控制，但是后来放弃了。原因是，数据在1 小时后会有过期机制，因此如果有数据无法进入系统，那么这些数据可能丢失。因此，我们还是尽量让数据进入Druid 系统，虽然偶尔会带来系统的峰值压力。<br />
基于Druid 的架构和数据流如下。<br />
　　　　　　　　　　　　　<a href="http://img.blog.csdn.net/20170313091001853?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvYnJvYWR2aWV3MjAwNg==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzAzMTMwOTEwMDE4NTM/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2WW5KdllXUjJhV1YzTWpBd05nPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></a><br />
　　　　　　　　　　　　　　　　　　　　　　　基于Druid 的架构和数据流</p>
<p>　　“纸上得来终觉浅，绝知此事要躬行”，如同学习其他技术一样，掌握Druid 最好的方法就是实践，因此大家在对Druid 有了一定的认识后应该尽快上手练习，并且争取早日将其应用到自己的实际工作中，在战斗中学习战斗，让在实践中碰到的问题驱动自己对Druid 技术的学习和理解。</p>
<p>　　<a href="http://www.broadview.com.cn/book/3695" rel="external nofollow noreferrer">本文选自《Druid实时大数据分析原理与实践》，点此链接可在博文视点官网查看此书。</a><br />
　　　　　　　　　　　　　　　　　　　　<a href="http://img.blog.csdn.net/20170313091310479?watermark/2/text/aHR0cDovL2Jsb2cuY3Nkbi5uZXQvYnJvYWR2aWV3MjAwNg==/font/5a6L5L2T/fontsize/400/fill/I0JBQkFCMA==/dissolve/70/gravity/SouthEast" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzAzMTMwOTEzMTA0Nzk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2WW5KdllXUjJhV1YzTWpBd05nPT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></a><br />
　　想及时获得更多精彩文章，可在微信中搜索“博文视点”或者扫描下方二维码并关注。<br />
　　　　　　　　　　　　　　　　　　　　　　　<a href="http://img.blog.csdn.net/20161128135240324" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjExMjgxMzUyNDAzMjQ=.jpg"></a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 12:36:50</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/%e5%a4%a7%e6%95%b0%e6%8d%ae/" title="大数据">大数据</a>, <a href="https://www.iamivan.net/tag/%e5%b0%8f%e7%b1%b3/" title="小米">小米</a>, <a href="https://www.iamivan.net/tag/druid/" title="druid">druid</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Druid 在小米公司部分技术实践的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M69JaOb.html" rel="bookmark">小米崔建伟答疑HBase在小米中的应用实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2014年3月25日,CSDN在线培训:HBase在小米中的应用实践圆满结束,本次培训讲师是来自小米的崔建伟,他表示随着小米业务的逐渐扩展,特别是大数据时代的到来,原有的关系型数据库MySQL已经逐渐无法满足需求,因此向NoSQL迁移是很自然的事情. CSDN在线培训是专为广大技术从业人员准备的在线实时互动技术培训,邀请各个行业一线技术工程师分享他们工作中遇见的各种问题以及解决方案,同时给大家带来一些新技术.思路.解决方案! CSDN在线培训以&quot;经典性.实战性.系统性.前瞻性.专业性&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9bBkQKM.html" rel="bookmark">阿里中间件技术专家魏鹏：基于Java容器的多应用部署技术实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首届阿里巴巴在线技术峰会(Alibaba Online Technology Summit),将于7月19日-21日 20:00-21:30 在线举办.本次峰会邀请到阿里集团9位技术大V,分享电商架构.安全.数据处理.数据库.多应用部署.互动技术.Docker持续交付与微服务等一线实战经验,解读最新技术在阿里集团的应用实践. 阿里巴巴在线技术峰会专题:https://yq.aliyun.com/activity/97峰会统一报名链接:https://yq.aliyun.com/webinar/j			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXqgXvz.html" rel="bookmark">小米公司新投资了无人机研发团队飞米</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要: 科技圈当下热点非无人机莫属,无论是闯入白宫还是助力汪峰求婚上头条,无人机曝光度逐日飙升,新时代大玩具的商用价值也正迅速挖掘.近日就有传闻,小米公司新投资了无人机研 科技圈当下热点非无人机莫属,无论是&quot;闯入&quot;白宫还是助力汪峰求婚上头条,无人机曝光度逐日飙升,新时代&quot;大玩具&quot;的商用价值也正迅速挖掘.近日就有传闻,小米公司新投资了无人机研发团队飞米.上周淘宝与圆通联合商家在北京等地特定区域进行了无人机送货服务. 随着在包括航拍.快递.安防领域被渐渐应用,无人机的商			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRDVx3z.html" rel="bookmark">大拿在跨国机房数据同步等方面的最佳技术实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				4月20日,云栖大会深圳峰会在大中华深圳喜来登酒店隆重召开.本文根据深圳市大拿科技有限公司副总王彬文在海外分会场中题为&lt;扬帆出海,阿里护航&gt;演讲整理而成.王彬文在演讲中深入分享了大拿所面临的技术挑战,以及如何成功实现跨国机房数据同步.高并发.大数据分析等方面的技术实践经验.   以下是演讲内容整理:   首先非常感谢阿里给予此次机会同大家一起交流分享下大拿在做国际业务时的经验.今天的分享主要分为两个部分:第一是大拿是做什么的?第二个部分是大拿在开拓海外市场的过程中遇到什么问题,阿里云帮助我们解			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQBQJZM.html" rel="bookmark">电商架构技术实践的秘诀：成功就在那里，快了才是你的！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				近期电商技术实战的内容非常丰富,4月15日在清华大学举办2016 ATF阿里技术论坛上的&lt;电商技术:零到三万亿,从未停止的技术创新&gt;,一次性分享了5位技术大神的技术干货: 淘宝移动平台事业部总经理庄卓然(南天):掌上精彩,连接过去与未来 阿里巴巴速卖通技术部总监郭东白(阿白):全球买全球卖,国际化的技术挑战 阿里巴巴资深总监司罗:阿里电商大脑,比你更懂你 阿里巴巴研究员墙辉(玄难):如何做电商业务中台 阿里巴巴研究员蒋江伟(小邪):双十一背后的分布式技术 不止这些.4月20日,云栖大会深圳峰会			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPBy21b.html" rel="bookmark">下一代超大规模软件定义网络技术实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				云计算的 IT 架构已经在企业应用中表现出明显优势,但网络设计理念却必须是一种推倒重来的思想.为了适应云计算的灵活.弹性扩展.高效和低成本,网络设计要进化为集中式软件管理,可编程化,控制转发层面分离等.本次陈海泉分享了关于下一代超大规模软件定义网络技术实践. 以下是本次分享的内容整理. 大家好,我是 QingCloud 的工程师陈海泉,今天给大家分享一些 SDN/NFV 2.0 架构的网络技术.我解释一下什么是 SDN,SDN 就是软件定义网络.当然也不是所有网络定制一定要软件来实现,因为有很多			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M94eNXb.html" rel="bookmark">全球最热门的NoSQL系统&mdash;&mdash;MongoDB技术实践与探索</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中国云计算产业最具影响力的盛会之一--2016杭州云栖大会(https://yunqi.aliyun.com/)将在云栖小镇召开.连续举办七届的云栖大会一直是业界了解阿里云计算生态发展和应用趋势.体验前沿技术和产品的最佳平台,来自海内外的上万名开发者.创业者聚集于此,分享着他们对云计算的思考与实践经验.7年来,从产品发布到行业解决方案展示,从关注技术到技术与服务并重,从单一的客户到生态全景的展现,大会的核心内容一直在&quot;进化&quot;,而2016年杭州云栖大会,则以&quot;飞天･进化&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1296xp.html" rel="bookmark">周卫林谈支付宝大数据技术实践及应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章讲的是周卫林谈支付宝大数据技术实践及应用,第三届Oracle技术嘉年华再度来袭!作为国内顶尖级别的Oracle数据库技术盛会,现场邀请到Jonathan Lewis,Tim Gorman等Oracle数据库领域国际级专家,特别为中国的数据库爱好者带来他们多年的总结与经验分享.另外,来自Linkedin.Salesforce.京东.1号店.百度.360.淘宝.阿里巴巴.支付宝.移动.联通等公司的核心数据库专家.架构师为各位朋友带来国内最新的数据库领域应用及最佳实践分享. ▲支付宝DW/BI高级			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDnjvOM.html" rel="bookmark">大规模代码构建技术实践</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在云效持续集成持续交付专场直播中,阿里技术专家何卫龙为大家带来了&lt;大规模代码构建技术实践&gt;的分享.本次分享主要从持续集成的背景,持续集成平台的演进过程,以及如何进行大规模持续集成构建三部分展开,内容精彩,不容错过. 以下内容根据讲师PPT和视频整理而成. 什么是持续集成? 大师Martin Fowler认为持续集成是一种软件开发实践,在实践中团队开发成员会频繁的进行任务的集成,通常每个成员每天都会集成一次,也就意味着每天可能会发生多次集成.每次集成都通过自动化的构建来验证,从而尽快地发现集成错			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnKJkz.html" rel="bookmark" class="title">PS为室内模特照片添加柔美紫色调教程</a>
					<div>
						柔淡的.富有梦幻般色彩的婚纱片从来不缺乏欣赏者和拥护者,它们以柔和和淡雅的色泽.轻而易举地营造出甜美的气息和浪漫的氛围.但是,这种柔美的色泽,在前期的拍摄中几乎不太可能完美的呈现出来,它需要后期调修师 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ybjZVVb.html" rel="bookmark" class="title">运营Blog的21个具体方法</a>
					<div>
						每天都有上千个新的BLOG发布,但是只有几百人阅读到它们.产生收益的BLOG更是少之又少.下面有21个方法,在你BLOG发布的头两周可以试试: 第一印象 1.通过about页面和欢迎词在你和读者间架起 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY2Dvep.html" rel="bookmark" class="title">如何在Linux操作系统下检测内存泄漏</a>
					<div>
						1．开发背景: 在 Windows 下使用 VC 编程时,我们通常需要 DEBUG 模式下运行程序,而后调试器将在退出程序时,打印出程序运行过程中在堆上分配而没有释放的内存信息,其中包括代码文件名.行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPQyrz.html" rel="bookmark" class="title">简单三步调出人物图片HDR效果</a>
					<div>
						教程的人物高清处理简单分为三步:第一步用阴影/高光把图片的明暗层次加大.第二步用色相/饱和度加强图片的饱和度.第三步用色阶等调色工具适当加大对比度即可. 原图 最终效果 1.打开原图素材,对图像图层执 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOe9WM.html" rel="bookmark" class="title">中国电信天翼宽带wifi使用方法</a>
					<div>
						(1)设置TCP/IP 在您的电脑上装好无线网卡后(笔记本您基本是已经安装好的),右键桌面网上邻居图标-属性, 在弹出窗口中会出现无线网络连接的图标,然后右键无线网络连接-属性, 在弹出窗口中双击常规 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7gY3M.html" rel="bookmark" class="title">6步处理好网络连接故障问题</a>
					<div>
						网络管理员会经常遇到网络连接故障,如果没有工具常常不知道如下手进行故障排除,下面介绍六个排查的基本步骤.可以了解如何通过正确的工具并按照6个简单的步骤操作来简化识别.隔离和解决边缘交换机和用户计算机之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY28orp.html" rel="bookmark" class="title">Win7安装Flash提示错误无法注册怎么办？</a>
					<div>
						  Win7安装Flash提示错误无法注册怎么办?          Win7系统中Falsh是大家浏览网页必须的组件,而在安装或更新Falsh时会遇到遇到错误无法注册ActiveX控件的问题导致安装 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7KZOM.html" rel="bookmark" class="title">Win7电脑桌面上QQ图标不见了怎么找回？</a>
					<div>
						最近使用Win7系统的用户反应,自己的电脑桌面上QQ图标突然不见了,那要如何找回桌面上的QQ图标呢?下面,小编就和大家说一下Win7电脑桌面上QQ图标不见了怎么找回. 方法如下: 1.首先,我们电脑点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGyZ1b.html" rel="bookmark" class="title">solidworks和proe哪个更好用？</a>
					<div>
						  相信学过机械设计的同学都知道solidworks与PROE这两款软件,SOLIDWORKS与PROE是被现在被广泛应用的三维设计软件,在功能上有很多相似的地方,不过又各具特点,那么这两款软件那个更 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZORZb.html" rel="bookmark" class="title">笔记本电脑不能开机，开机没反应怎么办</a>
					<div>
						  故障现象一:打开电源,按下开机按钮后,电脑无任何动静 分析:此时电源应向主板和各硬件供电,无任何动静说明是供电部分出了问题.(包括主板电源部分) 检查思路和方法: 1.市电电源问题,请检查电源插座 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArDj3p.html" rel="bookmark" class="title">系统中出现异常竖条</a>
					<div>
						  在系统中,经常出现一些异常的竖条或者不规则的小图案,这是怎么回事呢? 以上这种情况,可能是由于显卡的显存出现问题引起的,或者显卡与主板接触不好引起的.解决这种情况,可以用橡皮擦反复的擦拭显卡的金手 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQr3v0M.html" rel="bookmark" class="title">php类常量的使用详解&lowbar;php技巧</a>
					<div>
						注意:不像其他的面向对象编程语言,在php中,类不能对某个属性变量使用final修饰符.如果要声明某个属性为常量,可以使用const关键字,并且无需使用美元符号作为变量名前缀,也无需使用访问权限修饰符 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NNn7z.html" rel="bookmark" class="title">hibernate-Maven test一个Web项目，报错，弄了一天没弄好，求高手解答</a>
					<div>
						问题描述 Maven test一个Web项目,报错,弄了一天没弄好,求高手解答 org.springframework.beans.factory.BeanCreationException: Err ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYjvmrp.html" rel="bookmark" class="title">java语言中new A&lpar; &rpar;&period;B&lpar; &rpar;意思是不是A类的一个对象调用B方法</a>
					<div>
						问题描述 java语言中new A( ).B( )意思是不是A类的一个对象调用B方法 java语言中new A( ).B( )意思是不是A类的一个对象调用B方法如果是new A( ).B( ).... ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmW7Wz.html" rel="bookmark" class="title">从一个案例看mysqldump的复制选项</a>
					<div>
						写在前面  背景其实出现在两周前了,当时只是简单地排查了下原因就草草了事,今天再次仔细研究了下官方文档,发现还是有些嚼头的,多半是自己之前没有去刻意的思考,其实一点点小特性,有时候还是可以让我们的工作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqA4wYM.html" rel="bookmark" class="title">ubuntu-Ubunu 系统备份后恢复到另一块硬盘以后分区大小还是以前的</a>
					<div>
						问题描述 Ubunu 系统备份后恢复到另一块硬盘以后分区大小还是以前的 我本来用的是机械硬盘系统全部目录挂载在一个33G的分区中, 今天换了一块固态硬盘60G,把33G的系统备份后恢复到60G的固态硬 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRDyeKz.html" rel="bookmark" class="title">使用 Ansible 高效交付 Docker 容器</a>
					<div>
						使用 playbook.插件和 Docker 模块设置和扩展 Ansible 环境 Docker 和它的容器工作流可封装.共享和部署您的应用程序环境.Ansible 是一个与 Docker 高度兼容的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94vxgb.html" rel="bookmark" class="title">通过扩展改善ASP&period;NET MVC的验证机制&lbrack;使用篇&rsqb;</a>
					<div>
						原文:通过扩展改善ASP.NET MVC的验证机制[使用篇] ASP.NET MVC提供一种基于元数据的验证方式是我们可以将相应的验证特性应用到作为Model实体的类型或者属性/字段上,但是这依然具有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXy8jz.html" rel="bookmark" class="title">qwt的安装和移植-</a>
					<div>
						目需要根据实时数据绘制出图表,因此我们找到了qwt库,这个库是一个绘制图表,曲线图,柱状图的统计图标.... 下面我们就详细讲解一下这个库在Larm上的编译和移植 qwt介绍 QWT,全称是Qt Wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgD2Yb.html" rel="bookmark" class="title">巨人承认内部重组导致部分人员被优化掉</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 本土网游公司巨人网络(下称&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZgv9ab.html" rel="bookmark" class="title">SEO搜索引擎优化最新研究</a>
					<div>
						网站做SEO搜索引擎优化要随着搜索引擎的变化而应对,以上的测试都是针对百度来进行的,那些参数都是以前的老优化模式,百度的算法不断的在变化,作为一个SEO搜索引擎优化人,就必须亲自去测试,去实践,去分析 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZrX7z.html" rel="bookmark" class="title">关于新增阿里云等3家单位具备CNVD技术组成员单位资格的公告</a>
					<div>
						根据&lt;国家信息安全漏洞共享平台章程&gt;以及&lt;CNVD成员单位基本能力要求及申请流程指南&gt;,近期有多家单位向CNVD提交了加入技术组成员单位申请材料.其中,阿里云计算有限公司(简称 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Zxy6z.html" rel="bookmark" class="title">认知技术如何为能源公司提供帮助</a>
					<div>
						几年来,石油和天然气行业经验丰富的人员流失,造成经验丰富的人员与经验匮乏人员之间的断层. 技术咨询企业Information Services Group(ISG)的Energy Practice总监 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6Z4nXM.html" rel="bookmark" class="title">java 网页内容抓取-java网页内容抓取问题。</a>
					<div>
						问题描述 java网页内容抓取问题. 这个问题困扰我很久,谁能帮我解答我叫他哥了.问题是这样的,给个网站:http://www.wsdot.wa.gov/ferries/vesselwatch/Ter ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrq1yvb.html" rel="bookmark" class="title">iOS设计模式 - 抽象工厂</a>
					<div>
						iOS设计模式 - 抽象工厂   原理图   说明 1. 抽象工厂指的是提供一个创建一系列相关或者相互依赖对象的接口,而无需指定它们具体的类 2. 如果多个类有相同的行为,但实际实现不同,则可能需要某 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodXlEM.html" rel="bookmark" class="title">java 实现视频聊天功能的实现</a>
					<div>
						问题描述 java 实现视频聊天功能的实现 近来来储备知识,小弟已经在做视频聊天功能,现在是用opencv,现在主要是安装opencv之后,调取数据,程序老是说没有找到opencv的库,网上说open ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVQxrkp.html" rel="bookmark" class="title">CKEditor&sol;CKFinder升级心得</a>
					<div>
						这几天把一个旧项目中的fckeditor升级为ckeditor 3.2 + ckfinder 1.4.3 组合,下面是一些升级心得: 一.CKFinder的若干问题 1.单独使用ckfinder从原f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8x32b.html" rel="bookmark" class="title">查询网站外链又有新方法</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 yahoo早在年前就把查询外链功能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGrKyvp.html" rel="bookmark" class="title">Python遍历目录并批量更换文件名和目录名的方法&lowbar;python</a>
					<div>
						本文实例讲述了Python遍历目录并批量更换文件名和目录名的方法.分享给大家供大家参考,具体如下: #encoding=utf-8 #author: walker #date: 2014-03-07  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYrQZb.html" rel="bookmark" class="title">基于jquery实现动态竖向柱状条特效&lowbar;jquery</a>
					<div>
						本文实例介绍了jquery实现的柱状条,常用于数据统计,下面就对代码做一下分享,并详细介绍一下它的实现过程. 代码如下: &lt;html&gt; &lt;head&gt; &lt;meta char ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.038 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
